#ifndef __AGGR_H__
#define __AGGR_H__

#include <stdint.h>
#include "flow.h"

#define AGGREGATE_SLAB_SIZE 131072

typedef struct {
  uint8_t *key;
  uint64_t flows;
  uint64_t packets;
  uint64_t bytes;
} aggregate_t;

typedef struct aggregate_slab_s {
  struct aggregate_slab_s *next;
  aggregate_t aggregates[AGGREGATE_SLAB_SIZE];
} aggregate_slab_t;

typedef struct {
  const flow_field **fields;
  int num_fields;
  int key_length;
  aggregate_slab_t *slab;
  size_t count;
} aggregator_t;

aggregator_t *init_aggregator(int num_fields, char **field_names);
aggregate_t *aggregate_alloc(aggregator_t *aggregator);
uint8_t *aggregate_key(aggregator_t *aggr, flow_t *flow);

#endif /* __AGGR_H__ */
