#ifndef __AGGR_H__
#define __AGGR_H__

#include <stdint.h>
#include "Judy.h"
#include "flow.h"

#define AGGREGATE_SLAB_SIZE 131072

typedef struct {
  uint64_t flows;
  uint64_t packets;
  uint64_t bytes;
} aggregate_t;

typedef struct aggregate_slab_s {
  struct aggregate_slab_s *next;
  void *aggregates;
} aggregate_slab_t;

typedef struct {
  const flow_field **fields;
  int num_fields;
  int key_length;
  uint8_t *key_buffer;    /* Reusable buffer for assembling keys */
  aggregate_slab_t *slab;
  size_t count;
  Pvoid_t index;
} aggregator_t;

aggregator_t *init_aggregator(int num_fields, char **field_names);
void *aggregate_alloc(aggregator_t *aggregator);
void aggregate_flow(aggregator_t *aggregator, flow_t *flow);
void aggregate_merge(aggregator_t *aggregator, void *aggr);

#define KEY(p) (uint8_t *)(p + sizeof(aggregate_t))
#define AGGREGATE(p) (aggregate_t *)p

#endif /* __AGGR_H__ */
