#ifndef __FLOW_H__
#define __FLOW_H__

#include <stdint.h> /* uint*_t */
#include <stddef.h> /* size_t */

typedef struct {
  uint32_t start_time;
  uint32_t start_utime;

  uint32_t end_time;
  uint32_t end_utime;

  uint8_t proto;
  uint8_t tos;
  uint8_t flags;
  uint8_t pad;

  uint32_t src_ip;
  uint32_t dst_ip;
  uint16_t src_port;
  uint16_t dst_port;

  uint32_t src_as;
  uint32_t dst_as;

  uint16_t in_if;
  uint16_t out_if;

  uint32_t packets;
  uint32_t bytes;
} flow_t;

typedef struct {
  const char *name;
  size_t offset;
  size_t length;
} flow_field;

#define FLOW_FIELD(field) {                             \
    #field,						\
    offsetof(flow_t, field),                            \
    sizeof(((flow_t *)NULL)->field)                     \
}

extern const flow_field *flow_fields;

#endif /* __FLOW_H__ */
