#ifndef __SINK_H__
#define __SINK_H__

#include "aggr.h"

#include <sys/select.h>

#define BUFFER_SIZE 4096

typedef struct {
  int fd;
  aggregate_slab_t *slab;
  size_t slab_pos;
  size_t slab_count;
  char *buffer;
  size_t buffer_pos;
} sink_t;

int sink_hash(uint8_t *key, unsigned int len);
void sink_init(aggregator_t *aggregator, int nodes);
int sink_connect(char *address, int port);
void sink_add(int fd, aggregate_slab_t *slab, size_t slab_count);
void sink_close(sink_t *sink);
int sink_add_fds(fd_set *fds);
void sink_process(fd_set *fds, aggregator_t *aggregator);

#endif /* __SINK_H__ */
